export declare class TransactionError extends Error {
}
export declare class Transaction {
    static idInc: number;
    id: number;
    readonly: Boolean;
    began: Boolean;
    finished: Boolean;
    error: Error;
    commitListeners: Array<(Transaction) => Promise<any>>;
    rollbackListeners: Array<(Transaction) => Promise<any>>;
    constructor(readonly: boolean);
    begin(): void;
    hasBegun(): Boolean;
    markError(e: any): void;
    addCommitListener(f: any): void;
    addRollbackListener(f: any): void;
    /**
     * @return {Promise} A promise that executes all the callbacks necessary
     */
    end(): Promise<never>;
    canDo(readonly: any): any;
    isReadonly(): Boolean;
    callListeners(listeners: any): Promise<void> | Promise<[{}, {}, {}, {}, {}, {}, {}, {}, {}, {}]>;
}
export declare class TransactionManager {
    static newTransaction(readonly: any): Transaction;
}
